package de.hdm_stuttgart.mi.sd1.task1;


/**
 * <p>Getting clumps in array values.</p>
 */
public class D_Clump {

    /**
     * <p>Finding the number of clumps of identical values.</p>
     *
     * <p>A group of at least two mutually adjacent array members of identical value is being called a clump. Example:</p>
     *
     * <p>{0, <span style='color:red;font-weight:bold;'>-1, -1</span>, 3, 2, <span style='color:red;font-weight:bold;'>4, 4, 4</span>}</p>
     *
     * <p>This array harbours two clumps <code style='color:red;font-weight:bold;'>-1, -1</code> and
     * <code style='color:red;font-weight:bold;'>4, 4, 4</code> of adjacent identical values. Its clump count is
     * thus 2. Some more examples:</p>
     *
     * <table class="goikTableDefaults">
     *     <caption>Clump count examples</caption>
     *     <tbody>
     *         <tr>
     *             <th>Array</th>
     *             <th>Clump count</th>
     *         </tr>
     *         <tr>
     *             <td><code>null</code></td>
     *             <td>0</td>
     *         </tr>
     *         <tr>
     *             <td><code>{}</code></td>
     *             <td>0</td>
     *         </tr>
     *         <tr>
     *             <td><code>{4}</code></td>
     *             <td>0</td>
     *         </tr>
     *         <tr>
     *             <td><code>{4, -3, 4}</code></td>
     *             <td>0</td>
     *         </tr>
     *         <tr>
     *             <td><code>{0, <span style='color:red;font-weight:bold;'>9, 9</span>}</code></td>
     *             <td>1</td>
     *         </tr>
     *         <tr>
     *             <td><code>{<span style='color:red;font-weight:bold;'>-1, -1, -1</span>, 5, <span style='color:red;font-weight:bold;'>-1, -1, -1</span>, 4, <span style='color:red;font-weight:bold;'>3, 3, 3</span>}</code></td>
     *             <td>3</td>
     *         </tr>
     *         <tr>
     *             <td><code>{<span style='color:red;font-weight:bold;'>3, 3, 3, 3, 3, 3, 3, 3</span>}</code></td>
     *             <td>1</td>
     *         </tr>
     *     </tbody>
     * </table>
     *
     * <section class="implementationHints">
     *     <h4 class="implementationHints">Hints:</h4>
     *
     *     <ul>
     *         <li>You'll receive points for handling special cases e.g. <code>null</code> and
     *         <code>{ }</code>.</li>
     *     </ul>
     *
     * </section>
     *
     * @param values Integer values or <code>null</code> being treated like an empty array.
     *
     * @return The number of clumps containing neighbouring identical values or zero for an array value of
     *         <code class="java">null</code>.
     */
    static public int getClumpCount(final int[] values) {
        return -42; // Implement me correctly
    }

    private D_Clump(){/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
