package de.hdm_stuttgart.mi.sd1.task1;

/**
 * <p>Organizing a party.</p>
 */
public class A_Party {
    /**
     * <p>Choose people to invite.</p>
     *
     * <p>While organizing a party the host categorizes his contacts with respect to:
     *
     * <ul>
     *   <li>Being a friend.</li>
     *   <li>Being a customer.</li>
     *   <li>Past years average annual business related revenue. (Welcome to capitalism 💰 🤑)</li>
     * </ul>
     *
     * <p>A contact will be invited if at least one of the following is true:</p>
     *
     * <ul>
     *   <li>The contact is a friend</li>
     *   <li>The contact is a customer giving rise to at least 20000€ of annual revenue.</li>
     *
     * </ul>
     * @param isFriend Contact is a friend.
     * @param isCustomer Contact is a customer.
     * @param annualRevenue Past years average annual revenue.
     *
     * @return <code>true</code> if contact receives an invitation.
     */
    static public boolean getInvitation(boolean isFriend, boolean isCustomer, int annualRevenue) {
        return isFriend || isCustomer && 20000 <= annualRevenue;
    }

    private A_Party(){/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
