# Generate and open class/method javadoc for browsing

Grab a terminal in this IDE (By lower left icon or Alt+F12) and issue the following command:

<pre>Exam> mvn javadoc:javadoc
...
[<span style="color:blue;font-weight:bold;">INFO</span>] Executing tasks
[<span style="color:orange;font-weight:bold;">WARNING</span>]     [echo] Javadoc root at <span style="color:blue;">file:///home/.../Downloads/Exam/target/site/apidocs/index.html</span>
[<span style="color:blue;font-weight:bold;">INFO</span>] Executed tasks
...</pre>

Click the <span style="color:blue;">file:///.../index.html</span> link opening your project's  `index.html` Javadoc root
in your system's default web browser.

# Implementation tasks

Your project's following packages do contain implementation tasks:

- `de.hdm_stuttgart.mi.sd1.task1` 

- `de.hdm_stuttgart.mi.sd1.task2` (more difficult)

Read the generated documentation and implement the skeleton methods and classes.

Your project's  `test` branch does contain corresponding unit tests for verifying your solutions' correctness.

# Hints

- Your score solely depends on the number of successfully executing unit tests. A »nearly correct« implementation failing
with respect to a given unit tests will not contribute any points at all.

- General advice: Implement less but correctly.

- Mind special cases i.e. `null` variable values or null values being contained in arrays.

- In case of test failures both the IDEA debugger and logging statements are your friend.

Executing `de.hdm_stuttgart.mi.sd1.ShowReachedPoints` in your project's test branch as a Java application
(not as Junit test!) shows your number of points reached so far.

Do not model your implementations along unit test definitions i.e. avoid cheating this way! Such behaviour will be
regarded as an attempt at deception (Täuschungsversuch).

# Exam system upload

After finishing implementing:

1. Export this project by hitting **»File ➔ Export ➔ Project to Zip File«**.
1. Use a self-explanatory file name like e.g. `solution1.zip`.
1. Go to your exam browser window and upload `solution1.zip` .
1. Complete by  **clicking the »<span style="background: #527A35;color:white;">Speichern + weiter ➞ </span>«** button.
1. Hit **<span style="background: #446684;color:white;"> 🠬 Speichern + zurück</span>** and check if your
   upload is visible.
1. If you advance on implementing: Repeat steps 1. to 5.: Only the least uploaded `.zip` archive will become subject to
    marking.
