package de.hdm_stuttgart.mi.sd1.task2;

/**
 * <p>Check for matching wind conditions.</p>
 *
 * <p>Many water sport addicts depend on suitable wind conditions being described by wind speed and
 * optionally wind direction.</p>
 *
 * <p>We start an example forecasting <span style="color:green">40</span> Km Wind speed from north using
 * enum {@link Direction}:</p>
 *
 * <pre style="background-color: lightgray"><code class="nohighlight"> final WindForecast forecast = new WindForecast(<span style="color:green">40</span>, Direction.N);</code></pre>
 *
 * <p>A kitesurfer wants to get notified if the wind forecast at his or her spot predicts
 * wind ranging from <span style="color:blue">30</span> Km/h to <span style="color:red">50</span> Km/h in speed coming
 * either from northern ({@link Direction#N}) or northwestern ({@link Direction#NW}) directions.</p>
 *
 * <p>The <code>matchingConditions(...)</code> method in the following code snippet expects minimum and maximum desired
 * wind speed and a (possibly empty) list of desired wind directions. One of our surfer's desired directions being
 * {@link Direction#N} and the forcast of <span style="color:green">40</span> Km/h being within the desired <span style="color:blue">30</span> Km/h to
 * <span style="color:red">50</span> Km/h range calling <code>matchingConditions(...)</code> will thus return
 * <code>true</code>:</p>
 *
 * <pre  style="background-color: lightgray"><code class="nohighlight"> final WindForecast forecast = new WindForecast(<span style="color:green">40</span>, Direction.N);
 *
 * if (forecast.matchingConditions(<span style="color:blue">30</span>, <span style="color:red">50</span>, new Direction[]{Direction.N, Direction.NW})) {
 *    System.out.println("Yeah, let's go for it! \uD83D\uDE0E");
 * else {
 *    System.out.println("I hate waiting for the wind! \uD83E\uDD2C");
 * }</code></pre>
 *
 * <p>Complete the implementation of {@link WindForecast} allowing to run code like above using the
 * pre-defined enum {@link Direction}.</p>
 */
public class WindForecast {
    //TODO: Implement me!
}
