package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;




@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class C_WebUrlTest extends ExaminationTestDefaults {

    static private final String dnsNames[] = {
            "www.der-postillon.com", "www.duh.de", "www.amnesty.org"
    };


    @Test
    @Marking(points = 14)
    public void test() {

        for(final String dns: dnsNames) {
            final String
                    httpUrl = "http://" + dns,
                    httpsUrl = "https://" + dns,

                    actualByHttpsTlsTrue = C_WebUrl.amendWebAddress(httpsUrl, true),
                    actualByHttpsTlsFalse = C_WebUrl.amendWebAddress(httpsUrl, false),

                    actualByHttpTlsTrue = C_WebUrl.amendWebAddress(httpUrl, true),
                    actualByHttpTlsFalse = C_WebUrl.amendWebAddress(httpUrl, false),

                    actualByDnsTlsTrue = C_WebUrl.amendWebAddress(dns, true),
                    actualByDnsTlsFalse = C_WebUrl.amendWebAddress(dns, false);

            Assert.assertEquals(
                    "Passing '" + httpsUrl + "' should return '" + httpsUrl + "' rather than '" + actualByHttpsTlsTrue + "'",
                    httpsUrl, actualByHttpsTlsTrue);

            Assert.assertEquals(
                    "Passing '" + httpsUrl + "' should return '" + httpsUrl + "' rather than '" + actualByHttpsTlsFalse + "'",
                    httpsUrl, actualByHttpsTlsFalse);

            Assert.assertEquals(
                    "Passing '" + httpUrl + "' should return '" + httpUrl + "' rather than '" + actualByHttpTlsTrue + "'",
                    httpUrl, actualByHttpTlsTrue);

            Assert.assertEquals(
                    "Passing '" + httpUrl + "' should return '" + httpUrl + "' rather than '" + actualByHttpTlsFalse + "'",
                    httpUrl, actualByHttpTlsFalse);


            Assert.assertEquals(
                    "Passing '" + dns + "' when tlsSupport is 'true' should return '"  + httpsUrl + "' rather than " + actualByDnsTlsTrue,
                    httpsUrl, actualByDnsTlsTrue);

            Assert.assertEquals(
                    "Passing '" + dns + "' when tlsSupport is 'false' should return '"  + httpUrl + "' rather than " + actualByDnsTlsFalse,
                    httpUrl, actualByDnsTlsFalse);

        }
    }
}
