package de.hdm_stuttgart.mi.sd1.task2;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.reflect.ObjectWrapper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import static de.hdm_stuttgart.mi.sd1.task2.Direction.*;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)

public class WindForecastTest extends ExaminationTestDefaults {

    final ObjectWrapper<WindForecast> forecast_30_S =
            new ObjectWrapper<>(WindForecast.class, 30, S);

    @Test
    @Marking(points = 10)
    public void test_100_noDirection() {

        Assert.assertTrue("Forecast speed 30 being within [30, 40] expects true",
                forecast_30_S.invoke(boolean.class, "matchingConditions", 30, 40, new Direction[]{}));

        Assert.assertTrue("Forecast speed 30 being within [10, 40] expects true",
                forecast_30_S.invoke(boolean.class, "matchingConditions", 10, 40, new Direction[]{}));

        Assert.assertTrue("Forecast speed 30 being within [20, 30] expects true",
                forecast_30_S.invoke(boolean.class, "matchingConditions", 20, 30, new Direction[]{}));

        Assert.assertFalse("Forecast speed 30 outside [31, 40] expects false",
                forecast_30_S.invoke(boolean.class, "matchingConditions", 31, 40, new Direction[]{}));

        Assert.assertFalse("Forecast speed 30 outside [20, 29] expects false",
                forecast_30_S.invoke(boolean.class, "matchingConditions", 20, 29, new Direction[]{}));
    }

    @Test
    @Marking(points = 5)
    public void test_200_Direction() {

        Assert.assertTrue("Forecast speed 30 being within [30, 40] and direction containing S expects true",
                forecast_30_S.invoke(boolean.class, "matchingConditions", 30, 40,
                        new Direction[]{SE, SW, S}));

        Assert.assertFalse("Forecast speed 30 not within [31, 40] expects false",
                forecast_30_S.invoke(boolean.class, "matchingConditions", 31, 40,
                        new Direction[]{SE, SW, S}));

        Assert.assertFalse("Forecast speed 30 being within [30, 40] but direction not containing S expects false",
                forecast_30_S.invoke(boolean.class, "matchingConditions", 30, 40,
                        new Direction[]{N,NE,E,W,NW}));
    }
}
