DROP TABLE IF EXISTS Member2Project;
DROP TABLE IF EXISTS Project;
DROP TABLE IF EXISTS Member;
DROP TABLE IF EXISTS Department;

CREATE TABLE Department (
  name CHAR(255) PRIMARY KEY,
  parent CHAR(255) NULL REFERENCES Department
);

CREATE TABLE Member (
  nickname CHAR(20) PRIMARY KEY,
  name CHAR(255) ,
  department CHAR(255) NOT NULL REFERENCES Department
);

CREATE TABLE Project (
  slug CHAR(255) PRIMARY KEY,
  name CHAR(255) NOT NULL,
  visibility CHAR(20) NOT NULL,
  CHECK ( visibility in ('public', 'internal', 'private') )
);

CREATE TABLE Member2Project(
  project CHAR(255) REFERENCES Project,
  developer CHAR(20) REFERENCES Member,
  PRIMARY KEY (project, developer),
  role CHAR(20) NOT NULL,
  CHECK ( role in ('manager', 'guest', 'developer') )
);

INSERT INTO Department VALUES ('Headquarter', NULL);
INSERT INTO Department VALUES ('GUI Development', 'Headquarter');
INSERT INTO Department VALUES ('Database Development', 'Headquarter');

INSERT INTO Member VALUES ('jb', 'Jim Beam', 'Headquarter');

INSERT INTO Member VALUES ('eg', 'Eve Gardener', 'GUI Development');
INSERT INTO Member VALUES ('pt', 'Pete Townsend', 'GUI Development');
INSERT INTO Member VALUES ('ls', 'Laura Stern', 'Database Development');

INSERT INTO Project VALUES ('GUIGen', 'GUI Generator', 'public');
INSERT INTO Project VALUES ('dbSchemaGen', 'Database Schema Generator', 'internal');
INSERT INTO Project VALUES ('aBook', 'Address Book', 'private');

INSERT INTO Member2Project VALUES ('GUIGen', 'eg', 'manager');
INSERT INTO Member2Project VALUES ('GUIGen', 'jb', 'guest');

INSERT INTO Member2Project VALUES ('dbSchemaGen', 'pt', 'developer');

INSERT INTO Member2Project VALUES ('aBook', 'jb', 'manager');

SELECT * FROM Department;
SELECT * FROM Member;