package de.hdm_stuttgart.mi.sda1.test.ex1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.exam.unitmarking.xml.XmlTestSupport;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

/**
 * Generated by de.hdm_stuttgart.mi.unitmarking.xsd.GenerateUnitTestClass
 *
 * Unit test for an XML instance set. CLI by:
 * java -cp target/...-fat-tests.jar org.junit.runner.JUnitCore SchemaTest
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings("static-method")
public class SchemaTest extends ExaminationTestDefaults {

  private final XmlTestSupport xmlTestSupport = new XmlTestSupport("SchemaTest");

  @Test @Marking(points = 1)
  public void test_0100valid_Minimum() {
    xmlTestSupport.assertValid("0100valid_Minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0102invalid_missingProjects() {
    xmlTestSupport.assertInvalid("0102invalid_missingProjects.xml");
    xmlTestSupport.assertValid("0100valid_Minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0105invalid_missingDepartments() {
    xmlTestSupport.assertInvalid("0105invalid_missingDepartments.xml");
    xmlTestSupport.assertValid("0100valid_Minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0107invalid_missingProjectsDepartments() {
    xmlTestSupport.assertInvalid("0107invalid_missingProjectsDepartments.xml");
    xmlTestSupport.assertValid("0100valid_Minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0200valid_Department() {
    xmlTestSupport.assertValid("0200valid_Department.xml");
  }

  @Test @Marking(points = 1)
  public void test_0205invalidMissingName() {
    xmlTestSupport.assertInvalid("0205invalidMissingName.xml");
    xmlTestSupport.assertValid("0200valid_Department.xml");
  }

  @Test @Marking(points = 1)
  public void test_0300validDepartments() {
    xmlTestSupport.assertValid("0300validDepartments.xml");
  }

  @Test @Marking(points = 1)
  public void test_0305validDepHierarchy() {
    xmlTestSupport.assertValid("0305validDepHierarchy.xml");
  }

  @Test @Marking(points = 1)
  public void test_0307invalidDuplicateName() {
    xmlTestSupport.assertInvalid("0307invalidDuplicateName.xml");
    xmlTestSupport.assertValid("0305validDepHierarchy.xml");
  }

  @Test @Marking(points = 2)
  public void test_0350validDepartmentMember() {
    xmlTestSupport.assertValid("0350validDepartmentMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0355invalidMissingNickname() {
    xmlTestSupport.assertInvalid("0355invalidMissingNickname.xml");
    xmlTestSupport.assertValid("0350validDepartmentMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0360invalidwrongNickname() {
    xmlTestSupport.assertInvalid("0360invalidwrongNickname.xml");
    xmlTestSupport.assertValid("0350validDepartmentMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0365invalidDuplicateNickname() {
    xmlTestSupport.assertInvalid("0365invalidDuplicateNickname.xml");
    xmlTestSupport.assertValid("0350validDepartmentMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0400validProject() {
    xmlTestSupport.assertValid("0400validProject.xml");
  }

  @Test @Marking(points = 1)
  public void test_0405invalidMissingName() {
    xmlTestSupport.assertInvalid("0405invalidMissingName.xml");
    xmlTestSupport.assertValid("0100valid_Minimum.xml");
  }

  @Test @Marking(points = 1)
  public void test_0405invalidSlugTooShort() {
    xmlTestSupport.assertInvalid("0405invalidSlugTooShort.xml");
    xmlTestSupport.assertValid("0400validProject.xml");
  }

  @Test @Marking(points = 1)
  public void test_0405invalidSlugWhitespace() {
    xmlTestSupport.assertInvalid("0405invalidSlugWhitespace.xml");
    xmlTestSupport.assertValid("0400validProject.xml");
  }

  @Test @Marking(points = 1)
  public void test_0410invalidWrongVisibility() {
    xmlTestSupport.assertInvalid("0410invalidWrongVisibility.xml");
    xmlTestSupport.assertValid("0400validProject.xml");
  }

  @Test @Marking(points = 1)
  public void test_0415invalidMissingSlug() {
    xmlTestSupport.assertInvalid("0415invalidMissingSlug.xml");
    xmlTestSupport.assertValid("0400validProject.xml");
  }

  @Test @Marking(points = 1)
  public void test_0420invalidMissingVisibility() {
    xmlTestSupport.assertInvalid("0420invalidMissingVisibility.xml");
    xmlTestSupport.assertValid("0400validProject.xml");
  }

  @Test @Marking(points = 1)
  public void test_0425invalidDuplicateSlug() {
    xmlTestSupport.assertInvalid("0425invalidDuplicateSlug.xml");
    xmlTestSupport.assertValid("0400validProject.xml");
  }

  @Test @Marking(points = 1)
  public void test_0500validProjectMember() {
    xmlTestSupport.assertValid("0500validProjectMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0501validProjectNoMember() {
    xmlTestSupport.assertValid("0501validProjectNoMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0505invalidmissingMember() {
    xmlTestSupport.assertInvalid("0505invalidmissingMember.xml");
    xmlTestSupport.assertValid("0500validProjectMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0510invalidDuplicateMember() {
    xmlTestSupport.assertInvalid("0510invalidDuplicateMember.xml");
    xmlTestSupport.assertValid("0500validProjectMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0515invalidMissingRole() {
    xmlTestSupport.assertInvalid("0515invalidMissingRole.xml");
    xmlTestSupport.assertValid("0500validProjectMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0520invalidwrongRoleValue() {
    xmlTestSupport.assertInvalid("0520invalidwrongRoleValue.xml");
    xmlTestSupport.assertValid("0500validProjectMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0525invalidDuplicateRef() {
    xmlTestSupport.assertInvalid("0525invalidDuplicateRef.xml");
    xmlTestSupport.assertValid("0500validProjectMember.xml");
  }

  @Test @Marking(points = 1)
  public void test_0530invalidDanglingReference() {
    xmlTestSupport.assertInvalid("0530invalidDanglingReference.xml");
    xmlTestSupport.assertValid("0500validProjectMember.xml");
  }
}
